#!/bin/bash

#########################################################################
# This program is free software: you can redistribute it and/or modify  #
# it under the terms of the version 3 of the GNU General Public License #
# as published by the Free Software Foundation.                         #
#                                                                       #
# This program is distributed in the hope that it will be useful, but   #
# WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      #
# General Public License for more details.                              #
#                                                                       #
# You should have received a copy of the GNU General Public License     #
# along with this program. If not, see <http://www.gnu.org/licenses/>.  #
#                                                                       #
# Written by and Copyright (C) Francois Fleuret                         #
# Contact <francois@fleuret.org> for comments & bug reports             #
#########################################################################

while [ $1 ]; do

    NAME=$1

    REFERENCE=${NAME/MOV/JPG}

    if [[ -f ${REFERENCE} ]] && file ${REFERENCE} | \grep -q image; then
        # TAG=$(exif --ifd=EXIF -t "Date and Time (original)" ${REFERENCE} | grep Value)
        TAG=$(exif 2>/dev/null --ifd=EXIF -t 0x9003 ${REFERENCE} | grep Value)

        if [[ ! "${TAG}" ]]; then
            TAG=$(exif -t 0x0132 ${REFERENCE} | grep Value)
        fi

        if [[ ${TAG} ]]; then
            TIMESTAMP=$(echo ${TAG} | sed -e \
                "s/^ *Value: *\([0-9]*\):\([0-9]*\):\([0-9]*\) *\([0-9]*\):\([0-9]*\):\([0-9]*\).*$/\1\2\3\4\5.\6/")
            touch -t $TIMESTAMP ${NAME}
            ls -l ${NAME}
        else
            echo "++ No proper exif tag for ${NAME}, can not set the date properly."
        fi

    else
        echo "++ Can not find a reference picture file for ${NAME}, can not set the date properly."
    fi

    shift

done
